Subject: bug#67310: [PATCH] Include the project--list as history when prompting for a project

From: Juri Linkov <[email-masked]>
Date: Sun, 10 Dec 2023 19:43:21 +0200

>> This change broke the order of 'C-x p p M-n M-n ...',
>
> Could you remind me which behavior in 'M-n M-n' the aforementioned change
> relates to? Is this supposed to be like input history as well, or the
> contents of the completions table in a certain order?

It's inappropriate to overwrite the history with the recently visited projects.
Only user input should be added to history variables because it's actually
the history of user input.  Therefore, the remaining way to access a list
of recently visited projects is the future history with 'M-n M-n'.

> I just tried find-file, and the future history is empty there, so I suppose
> this is something we added particularly for project-find-file.

Unlike with project--list, we don't keep a list of recently visited files.
Once we conducted an experiment to add all visited files to the input file history,
even when a file was visited without reading a file name in the minibuffer,
e.g. by typing RET in Dired.  But no one liked this behavior.